/*
 * Calculadora.java
 *
 * Created on 21 de mayo de 2006, 21:05
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import javax.swing.*;
import java.applet.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;



/**
 *
 * @author Administrador
 */
public class Calculadora extends JApplet {
    
    Pantalla pantalla = new Pantalla();
    
    /**
     * 
     ** Inicializa la calculadora
     */
    public void init() {
        
        setLayout(new BorderLayout());
        
        // crea un objeto Teclado
        Teclado teclado = new Teclado();
        
        // aade al Norte el visor de
        // la calculadora
        add("North", pantalla);
        
        // aade al centro el teclado
        add("Center", teclado);
        
    }
    
    /**
     * Creates a new instance of Calculadora 
     */
    public Calculadora() {
    }
    public static void main(String args []){
        
        JFrame jfr = new JFrame("Calculadora");
        
        // crea el objeto calculadora
        Calculadora calc = new Calculadora();
        
        // inicializacin de la calculadora
        calc.init();
        
        // tamao del Frame
        jfr.setSize(250,200);
        
        // la calculadora va al centro del JFrame
        jfr.add("Center", calc);
        jfr.setVisible(true);
        
    }
    
    class Teclado extends JPanel implements ActionListener{
        
        // la clase Teclado tiene los botones
        // y los eventos de botn
        JButton jb1;
        JButton jb2;
        JButton jb3;
        JButton jb4;
        JButton jb5;
        JButton jb6;
        JButton jb7;
        JButton jb8;
        JButton jb9;
        JButton jb0;
        JButton jbSumar;
        JButton jbRestar;
        JButton jbMulti;
        JButton jbDivis;
        JButton jbComa;
        JButton jbCancel;
        JButton jbIgual;
        Teclado() {
            
            // fuente de los botones
            Font font= new Font("Arial", Font.BOLD,12);
            
            // color de las teclas de funcin
            Color tfColor =new Color(255,255,0);
            
            // color de las teclas de nmeros
            Color tnColor = new Color(0,255,255);
  
            // se asigna al fuente
            setFont(font);
            
            // primera lnea del teclado
            jb7 = new JButton("7");
            // se ade el botn al contenedor JPanel
            add(jb7);
            // se asigna el color de fondo
            jb7.setBackground(tnColor);
            // se registra el servicio de escucha del evento clic
            jb7.addActionListener(this);
            
            jb8 = new JButton("8");
            add(jb8);
            jb8.setBackground(tnColor);
            jb8.addActionListener(this);
            
            jb9 = new JButton("9");
            add(jb9);
            jb9.setBackground(tnColor);
            jb9.addActionListener(this);
            
            jbDivis = new JButton("/");
            add(jbDivis);
            jbDivis.setBackground(tfColor);
            jbDivis.addActionListener(this);
            
            // segunda lnea del teclado
            jb4 = new JButton("4");
            add(jb4);
            jb4.setBackground(tnColor);
            jb4.addActionListener(this);
            
            jb5 = new JButton("5");
            add(jb5);
            jb5.setBackground(tnColor);
            jb5.addActionListener(this);
            
            jb6 = new JButton("6");
            add(jb6);
            jb6.setBackground(tnColor);
            jb6.addActionListener(this);
            
            jbMulti = new JButton("*");
            add(jbMulti);
            jbMulti.setBackground(tfColor);
            jbMulti.addActionListener(this);
            
            // tercera lnea del teclado
            jb1 = new JButton("1");
            add(jb1);
            jb1.setBackground(tnColor);
            jb1.addActionListener(this);
            
            jb2 = new JButton("2");
            add(jb2);
            jb2.setBackground(tnColor);
            jb2.addActionListener(this);
            
            jb3 = new JButton("3");
            add(jb3);
            jb3.setBackground(tnColor);
            jb3.addActionListener(this);
            
            jbRestar = new JButton("-");
            add(jbRestar);
            jbRestar.setBackground(tfColor);
            jbRestar.addActionListener(this);
            
            // cuarta lnea del teclado
            jbComa = new JButton(",");
            add(jbComa);
            jbComa.setBackground(tnColor);
            jbComa.addActionListener(this);
            
            jb0 = new JButton("0");
            add(jb0);
            jb0.setBackground(tnColor);
            jb0.addActionListener(this);
            
            jbIgual = new JButton("=");
            add(jbIgual);
            jbIgual.setBackground(tfColor);
            jbIgual.addActionListener(this);
            
            jbSumar = new JButton("+");
            add(jbSumar);
            jbSumar.setBackground(tfColor);
            jbSumar.addActionListener(this);
            
            // quinta lnea del teclado
            jbCancel = new JButton("C");
            add(jbCancel);
            jbCancel.setBackground(tnColor);
            jbCancel.addActionListener(this);
            
            
            add(new JLabel(" "));
            add(new JLabel(" "));
            add(new JLabel(" "));
            // se asigna la distribucin dentro de JPanel
            setLayout(new GridLayout(5,4,4,4));
            setVisible(true);
            
            
            
        }
        // los clic se reciben finalmente en el mtodo
        // actionPerformed
        public void actionPerformed(ActionEvent e){
            // averiguar el origen del evento
            Object obj = e.getSource();
            
            // clics en nmeros tienen un tratamiento
            if (obj == jb0){
                pantalla.Nmero("0");
            }
            if (obj == jb1){
                pantalla.Nmero("1");
            }
            if (obj == jb2){
                pantalla.Nmero("2");
            }
            if (obj == jb3){
                pantalla.Nmero("3");
            }
            if (obj == jb4){
                pantalla.Nmero("4");
            }
            if (obj == jb5){
                pantalla.Nmero("5");
            }
            if (obj == jb6){
                pantalla.Nmero("6");
            }
            if (obj == jb7){
                pantalla.Nmero("7");
            }
            if (obj == jb8){
                pantalla.Nmero("8");
            }
            if (obj == jb9){
                pantalla.Nmero("9");
            }
            
            
            // clic en botones de clculo
            if (obj == jbRestar){
                pantalla.Clculo("R"); // Resta
            }
            if (obj == jbSumar){
                pantalla.Clculo("S"); // Suma
            }
            if (obj == jbMulti){
                pantalla.Clculo("M"); // Multiplicacin
            }
            if (obj == jbDivis){
                pantalla.Clculo("D"); // Divisin
            }
            
            // clic en botn Cancelar
            if (obj == jbCancel){
                pantalla.Cancelar(); // Limpiar
            }
            
            // Poner coma
            if (obj == jbComa){
                pantalla.Coma();
            }
            
            // ver resultado
            if (obj == jbIgual){
                pantalla.Igual(); // tecla igual
            }
        }
    }
    class Pantalla extends JPanel {
        boolean igual = false;
        double memoria = 0;
        String op = " ";       
        int longMxima = 8;
        String str;
        Label resultado = new Label("");
        
        Pantalla() {
            // distribucin de la pantalla  
            setLayout(new BorderLayout());
            
            // color de fondo del visor
            setBackground(Color.white);
            
            // letra del visor
            setFont(new Font("Courier",  Font.BOLD + Font.ITALIC, 24));
            
            // alineacin de la etiqueta del resultado
            resultado.setAlignment(1);
            
            // aadir el componente
            add("Center" , resultado);
            repaint();
            
            // limpiar
            Cancelar();
        }
        
        void Nmero(String strn) {
            // clic en un nmero
            verificaIgual();
            
            // quitar el cero de adelante
            if(str.charAt(0) == '0') str = str.substring(1);
            
            // no permite exceso de longitud
            if (str.length() < longMxima)
                str = str + strn;
            
            mostrarMem();
        }
        
        void Coma() {
            // pone la coma si es que ya no hay otra
            verificaIgual();
            
            // comprueba que ya no haya coma previa
            if (str.indexOf('.') != -1) return;
            
            // no permite exceso de longitud
            if (str.length() < longMxima)
                str = str + ".";
            
            mostrarMem();
            
        }
        
        private void verificaIgual() {
            // si lo ltimo fue la tecla igual
            // se pone a cero y se limpia
            if (igual == true) {
                igual = false;
                str = "0";
            }
        }
        
                
        private void Clculo(String oper) {
            // clculo de la operacin
            if (str.length() == 0) return;
            if (op!="" ) Igual();
            
            // se guarda la operacin pedida
            op = oper;
            
            // se memoriza el valor en pantalla
            Double dbl = Double.valueOf(str);
            memoria = dbl.doubleValue();
            
            // se limpia la pantalla
            igual = false;
            str = "0";
        }
        
        void Igual() {
            // clic en tecla igual
            
            double temp = 0;
            if (str.length() ==0) return;
            Double dbl = Double.valueOf(str);
            if (op=="S"){
                temp = memoria + dbl.doubleValue();
            }
            if (op=="R"){
                temp = memoria - dbl.doubleValue();
            }
            if (op=="M"){
                temp = memoria * dbl.doubleValue();
            }
            if (op=="D"){
                temp = memoria / dbl.doubleValue();
            }
            str = new Double(temp).toString();
            mostrarMem();
            igual = true;
            memoria = 0;
            op = "";
        }
        
        void Cancelar(){
            // limpia memoria y visor
            igual = false;
            memoria = 0;
            op = "";
            str = "0";
            mostrarMem();
        }
        
        private void mostrarMem() {
            // muestra el valor en memoria
            resultado.setText(str);
            repaint();
        }
    }
}
