/*
 * Ejemplo1201Ventana.java
 *
 * Created on 25 de abril de 2006, 22:55
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 *
 * @author Administrador
 */
// Se extiende JFrame
public class Ejemplo1201Ventana extends JFrame{
    
    // JButton es una implementacn de un botn
    // de pulsacin.
    
    JButton btnSalir;
    JButton btnSaludar;
    
    // JLabel nos permite insertar texto en la ventana
    JLabel lblSaludo;
    
    // JTextField es una implementacn de
    // un cuadro de texto
    JTextField txtNombre;
    
    /** Creates a new instance of Ventana */
    public Ejemplo1201Ventana() {
        super("Nuestro ttulo");
        
        // el mtodo getContentPane devuelve
        // el objeto contentPane para este frame
        //  El objeto Container es un objeto que puede
        //  contener otros componentes AWT
        Container cp = getContentPane();
        
        // setPreferredSize es un mtodo que proviene
        // de la clase Component
        // que asigna el tamao preferido de este componente
        cp.setPreferredSize(new Dimension(200,100));
        
        // el mtodo setLayout es un mtodo
        // no heredado, es propio de la clase
        // Container
        // define cmo se distribuyen los
        // componentes en el contenedor
        cp.setLayout(new FlowLayout());
        
        // el mtodo add aade un componente
        // al contenedor siguiendo el layout
        // (distribucin definida)
        
        cp.add(txtNombre = new JTextField(""));
        txtNombre.setPreferredSize(new Dimension(50,20));
        
        // se aade otro componente
        cp.add(lblSaludo = new JLabel());
        
        // se aade otro componente
        lblSaludo.setPreferredSize(new Dimension(70,40));
        cp.add(btnSalir = new JButton("Salir"));
        
        // se aade otro componente
        cp.add(btnSaludar = new JButton("Saludar"));
        
        
        
        // el mtodo addActionListener se hereda de la clase
        // Container
        // avisa que se atiendan los eventos del componente
        // aqu se crea una instancia de clase annima que se
        // cierra en el smbolo });
        // por lo tanto, el objeto ActionListener no tiene nombre
        // de ejemplar. Enumerationeste caso, el nombre ser interno
        // y lo asignar el compilador
        btnSalir.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent d){
                System.out.println("btnSalir -> Evento:" + d);
                
                setVisible(false);
                // el metodo dispose() se hereda de Window y su accin
                // es la de liberar los recursos del sistema de
                // ventanas sin destruir completamente la ventana
                // al llamar despus a pack se vuelven a crear los
                // recursos (lo mismo sucede con setVisible(true)
                dispose();
                
                // la clase exit() termina la JVM que se est
                // ejecutando.
                // Lo mismo sera:
                // Runtime.getRuntime().exit()
                // Tengase en cuenta que un programa no termina
                // simplemente con "Cerrar ventana" (esto sucede
                // con ventanas JFrame o JDialogs)
                System.exit(0);
            }
            // aqu se cierra la definicin de la clase annima
        });
        
        // otra clase annima:
        // el mtodo addActionListener se hereda de la clase
        // Container
        // avisa que se atiendan los eventos del componente
        btnSaludar.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent d){
                System.out.println("btnExec -> Evento:" + d.getID());
                System.out.println("Nombre es :" + txtNombre.getText());
                
                // se actualiza la etiqueta
                // con el texto del cuadro de texto
                lblSaludo.setText("Hola, " + txtNombre.getText());
                
                // cambiamos el ttulo en la ventana
                setTitle("propietario: " + txtNombre.getText());
            }
        });
        
        
        
        // mtodo heredado de java.awt.Window
        // hace que la ventana se dimensione al
        // tamao de setPreferredSize y
        // distribuye los componentes
        super.pack();
        
        // mtodo heredado de java.awt.Window
        // es similar a setVisible(true)
        // el mtodo show est quedando obsoleto
        // es preferible usar setVisible(true)
        super.show();
    }
    public static void main(String args[]){
        new Ejemplo1201Ventana();
    }
    
}
