/*
 * Main.java
 *
 * Created on 19 de abril de 2006, 0:04
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package cap09;
import org.ed.mibib.*;

/**
 *
 * @author Administrador
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // uso de la clase String
        Ejemplo0901();
        
    }
    public static void Ejemplo0901() {
        
        // constructores de String
        System.out.println("Uso de constructores de String");
        // Creacin de un objeto String
        String str1 = new String("Libro de Java");
        System.out.println("1. " + str1);
        
        char c[] = {53,54,50,53};
        String str2 = new String(c);
        System.out.println("2. " + str2);
        
        String str3 = new String(c,2,2);
        System.out.println("3. " + str3);
        
        byte d[] = {53,54,50,58};
        String str4 = new String(d);
        System.out.println("4. " + str4);
        
        String str5 = new String(d,1,3);
        System.out.println("5. " + str5);
        
        String str6 = str5;
        System.out.println("6. " + str6);
        
        
        
        // comparacin de cadenas ==, compareTo, equals
        System.out.println("Comparacin de cadenas");
        if (str5==str6)
            System.out.println("== : str5 y str6 son iguales");
        
        if (str5.compareTo(str6)==0)
            System.out.println("compareTo: str5 y str6 son iguales");
        
        if (str5.equals(str6))
            System.out.println("equals: str5 y str6 son iguales");
        
        // concat
        System.out.println("Uso de concat");
        // concatenacin de cadenas
        String str7 = str5 + str6;
        System.out.println("7. " + str7);
        
        String str8 = str5.concat(str6);
        System.out.println("8. " + str8);
        
        // true
        if (str7.equals(str8))
            System.out.println("equals: str7 y str8 son iguales");
        
        
        // contains
        System.out.println("Uso de contains");
        // contiene una secuencia de caracteres? true
        String seq  = "62";
        if (str7.contains(seq))
            System.out.println("contains: str7 contiene 62");
        
        // contentEquals
        System.out.println("Uso de contentEquals");
        if (str7.contentEquals(seq))
            System.out.println("contentEquals: str7 contiene slo 62");
        else System.out.println("contentEquals: str7 no contiene slo 62");
        
        // charAt
        System.out.println("Uso de charAt");
        // valor char en una posicin
        String str1a = "abcd";
        char ch1a = str1a.charAt(2);
        // la respuesta ser c
        System.out.println("charAt: posicin 2 (contada desde 0):" + ch1a);
        
        // codePointAt
        System.out.println("Uso de codePointAt");
        // valor punto cdigo Unicode en una posicin
        // tr1a = "abcd";
        int i1a = str1a.codePointAt(2);
        // la respuesta ser 99
        System.out.println("codePointAt 1: pos. 2 (contada desde 0):" + i1a);
        i1a = str1a.codePointAt(3);
        // la respuesta ser 100
        System.out.println("codePointAt 2: pos. 3 (contada desde 0):" + i1a);
        
        // codePointCount
        System.out.println("Uso de codePointCount");
        // cuenta los puntos cdigo Unicode en un rango
        // tr1a = "abcd";
        i1a = str1a.codePointCount(0, 3);
        // la respuesta ser 99
        System.out.println("codePointCount: " + i1a);
        
        
        // codePointBefore
        System.out.println("Uso de codePointBefore");
        // valor punto cdigo Unicode en una posicin anterior
        // tr1a = "abcd";
        i1a = str1a.codePointBefore(3);
        // la respuesta ser 99
        System.out.println("codePointBefore: pos. 3 -1 (contada desde 0):" + i1a);
        
        // copyValueOf
        System.out.println("Uso de copyValueOf");
        // genera una cadena a partir de una matriz char
        // ABCDEFGHIJK
        char ch1[] = {65,66,67,68,69,70,71,72,73,74,75};
        // selecciona 67 68 69
        String str9 = String.copyValueOf(ch1, 2, 3);
        System.out.println("copyvalueOf: str9 " + str9);
        
        // endsWith
        System.out.println("Uso de endsWith");
        // verifica si una cadena termina con una subcadena determinada
        if (str9.endsWith("E"))
            System.out.println("endsWith: str9 termina con E");
        
        // getBytes
        System.out.println("Uso de getBytes");
        // genera una matriz byte a partir de una cadena
        byte b[] = str9.getBytes();
        // la respuesta ser 67
        System.out.println("getBytes: b " + b[0]);
        // la respuesta ser 3
        System.out.println("length: b " + b.length);
        
        // hashCode
        System.out.println("Uso de hashCode");
        // str9 es CDE
        System.out.println("hashCode: de la cadena CDE es " + str9.hashCode());
        
        
        
        // getChars
        System.out.println("Uso de getChars");
        // M N O
        char ch2 [] ={77,78,79};
        // str9 es CDE
        System.out.println("getChars: str9 es " + str9);
        str9.getChars(0, 2, ch2, 1);
        // ch2 quedar como MCD
        System.out.println("getChars: ch2 es " + ch2[0]+ch2[1]+ch2[2]);
        
        // indexOf
        System.out.println("Uso de indexOf");
        // busca la aparicin del caracter char 69 (letra E)
        // la respuesta ser 2
        System.out.println("indexOf 1:    " + str9.indexOf(69));
        
        // busca la aparicin de la letra C
        // la respuesta ser 0
        System.out.println("indexOf 2:    " + str9.indexOf("C"));
        
        // intern
        // forma cannica
        String str10 = str9.intern();
        // la respuesta ser CDE
        System.out.println("intern:    " + str10);
        
        // lastIndexdOf
        System.out.println("Uso de lastIndexOf");
        // busca la ltima aparicin de una subcadena
        // length
        // indexOf
        String str11 = "Libro de Java";
        // ltima aparicin de "a"
        // la respuesta ser 12
        System.out.println("longitud de la cadena :    " + str11.length());
        System.out.println("ltima a:    " + str11.lastIndexOf("a"));
        // primera  aparicin de "a"
        // la respuesta ser 10
        System.out.println("primera a:    " + str11.indexOf("a"));
        
        // matches
        String str12 = "abc";
        // la respuesta ser true
        System.out.println("coincide:    " + str12.matches("abc"));
        
        
        //regionMatches
        System.out.println("Uso de regionMatches");
        String str13 = "J.Carlos";
        String str14 = "juan carlos";
        // la respuesta ser false porque diferencia maysculas de minsculas
        System.out.println("regionMatches:  " + str13.regionMatches(2, str14, 5,6 ));
        // la respuesta ser true porque NO diferencia maysculas de minsculas
        System.out.println("regionMatches:  " + str13.regionMatches(true, 2, str14, 5,6 ));
        // Pero la respuesta de regionMatches tambin puede ser false por otras razones:
        // 1) si alguno de los argumentos (o los dos) que indican el desplazamiento en
        // las cadenas fuese negativo.
        // 2) si desplazamiento + longitud del segundo String sale de los lmites
        // del primer String
        // 3) Si el desplazamiento del primer String + longitud del primer String
        // sale de los lmites del segundo String
        
        
        // replace
        System.out.println("Uso de replace");
        // genera una cadena a partir del reemplazo de secuencia de caracteres
        String str15 = str13.replace("J.", "Juan ");
        // la respuesta ser Juan Carlos
        System.out.println("replace:  " + str15);
        
        // replaceAll
        System.out.println("Uso de replaceAll");
        // genera una cadena a partir del reemplazo de secuencia de caracteres
        String str16 = "abcdefghi abcdefghi";
        // la respuesta ser xxcdefgxi xxcdefgxi
        System.out.println("replaceAll 1:  " + str16.replaceAll("[abh]", "x"));
        
        // la respuesta ser abcd111hi abcd111hi
        System.out.println("replaceAll 2:  " + str16.replaceAll("[e-g]", "1"));
        
        // split
        System.out.println("Uso de split");
        // divide una cadena en una matriz de cadenas
        // tomando en cuenta y separador
        String str17 = "a-bcde-fghi-abc-defghi";
        // se define el smbolo "-" como el separador
        String str18[] = str17.split("[-]");
        int i;
        // tiene que haber generado una matriz de 5 elementos
        for (i=0;i<str18.length;i++)
            System.out.println("split: str18 i:  " + i + ">" + str18[i]);
        
        // si se quiere limitar la cantidad de elementos de la matriz
        // por ejemplo: slo 3
        String  str18a[] = str17.split("[-]",3);
        // tiene que haber generado una matriz de 3 elementos
        // el elemento 0 y  el 1 son iguales al caso anterior
        // valores: a y bcde
        // pero el elemento 2 (el tercero) tiene el
        // resto de la cadena
        // valor: fghi-abc-defghi
        // ya que deja de analizar la cadena en busca de
        // separadores (en este caso, "-")
        for (i=0;i<str18a.length;i++)
            System.out.println("split 2: str18a i:  " + i + ">" + str18a[i]);
        
        
        
        // startsWith
        System.out.println("Uso de startsWith");
        // verifica si una cadena comienza con una
        // cadena determinada
        String str19 = "http://www.inforbooks.com";
        if (str19.startsWith("http:"))
            System.out.println("startsWith 1:  comienza con http");
        // verifica un contenido en una posicin determinada
        if (str19.startsWith("www.", 7))
            System.out.println("startsWith 2:  es una direccin www.");
        
        // subSequence
        System.out.println("Uso de subSequence");
        // tiene un comportamiento similar a substring
        // genera una subcadena a partir de una cadena
        String str20 = "Ttulo del libro: Java";
        // extraeremos el nombre del libro
        int i1 = str20.lastIndexOf(": ");
        System.out.println("El nombre del libro comienza en : " + (i1+2) );
        int j1 = str20.length();
        System.out.println("La longitud de la cadena es " + j1);
        System.out.println("subSequence :" + str20.subSequence(i1+2,j1));
        
        // con substring
        System.out.println("Uso de substring");
        // es idntico a subSequence
        System.out.println("substring 1:" + str20.substring(i1+2,j1));
        
        // tambin es vlido y en este caso con resultado idntico
        // sin usar el segundo parmetro
        System.out.println("substring 2:" + str20.substring(i1+2));
        
        // toCharArray
        System.out.println("Uso de toCharArray");
        // genera una matriz char a partir de una cadena
        char ch3[];
        String str21 = "13579";
        ch3 = str21.toCharArray();
        // el resultado ser ch3[0] = 1 ... ch3[4]=9
        for (i=0;i<ch3.length;i++)
            System.out.println("toCharArray : ch3 i:  " + i + ">" + ch3[i]);
        
        
        // toLowerCase
        System.out.println("Uso de toLowerCase");
        // cambia las maysculas a minsculas
        String str22 = "  DEBE/HABER --> Saldo  ";
        // observar que las minsculas quedan como estn
        System.out.println("toLowerCase :" + str22 + ": se convierte en :" + str22.toLowerCase());
        
        
        // toUpperCase
        System.out.println("Uso de toUpperCase");
        // cambia las minsculas a maysculas
        // str22 = "  DEBE/HABER --> Saldo  ";
        // observar que las maysculas quedan como estn
        System.out.println("toUpperCase :" + str22 + ": se convierte en :" + str22.toUpperCase());
        
        // trim
        System.out.println("Uso de trim");
        // recorte de blancos en las cadenas
        // str22 = "  DEBE/HABER --> Saldo  ";
        // observar que cmo desaparecen los blancos al inicio y al final
        System.out.println("trim :" + str22 + ": se convierte en :" + str22.trim());
        
        // valueOf
        System.out.println("Uso de valueOf");
        // devuelve la representacin de cadena de un tipo de datos
        double d2 = 1234.5678;
        System.out.println("valueOf d2 se representa como :" + String.valueOf(d2));
    }
}
