/*
 * Main.java
 *
 * Created on 21 de abril de 2006, 17:25
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package cap09c;
import org.ed.mibib.*;
import java.util.*;

/**
 *
 * @author Administrador
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // ejemplos sobre el uso de matrices
        
        int i[] = {22, 345, 587, 999};
        float f[] = {22.22f, 345.33f, 587.55f, 999.6f};
        char ch[] = {'H', 'i', 'o'};
        double d[] = {22.22, 345.33, 587.55, 999.6};
        String s[] = {"Hola", "Java", ":"};
        
        for (int k=0; k < i.length; k++) {
            System.out.println(i[k]);
            
        }
        
        // otro modo de recorrer una matriz
        System.out.println("sentencia for sintaxis para recorrer matrices");
        // no se utiliza el mtodo length
        for (float e : f)
            System.out.println(e);
        
        
        // calcula el sumatorio de la matriz
        System.out.println("clculo del sumatorio");
        float sumat = 0;
        for (int k=0; k < f.length; k++) {
            // suma todos los elementos de la matriz
            sumat += f[k];
        }
        System.out.println("Sumatorio de matriz f " + sumat);
        
        
        
        // asigna cero a todos los elementos
        for (int k=0; k < i.length; k++) {
            i[k] = 0;
        }
        
        
        // matriz de dos dimensiones
        int ib [][] = new int[3][4];
        
        // inicializar la matriz con 0
        int iFila, iCol;
        
        for (iFila=0; iFila < 3;iFila++) {
            for (iCol=0;iCol< 4 ; iCol++){
                ib[iFila] [iCol] = 0;
            }
        }
        
        
        // matriz de dos dimensiones
        int ib2 [][] = new int[3][4];
        
        // inicializar la matriz con
        // valores sucesivos
        int iEle = 0;
        for (iFila=0; iFila < 3;iFila++) {
            for (iCol=0;iCol< 4 ; iCol++){
                ib2[iFila] [iCol] = ++iEle;
                System.out.println("Fila:" + iFila + " Columna:" + iCol);
                System.out.println(ib2[iFila] [iCol]);
            }
        }
        
        // otro modo ms simple de recorrer una matriz
        // bidimensional sin preocuparnos
        // de los ndices
        for (int[] ea : ib2){
            for (int eb : ea){
                System.out.println(eb);
            }
        }
        
        
        // definicin fila 1, columna 1 = 11
        // definicin fila 1, columna 2 = 12
        // definicin fila 2, columna 1 = 21
        //...
        // definicin fila 3, columna 2 = 32
        // define una matriz de 3 filas por 2 columnas
        int ia[][] = { { 11 , 12}, {21, 22}, {31, 32}};
        // listar la matriz
        for (int[] ea1 : ia){
            for (int eb1 : ea1){
                System.out.println(eb1);
            }
        }
        
        // uso de la clase vector
        System.out.println("Uso de la clase Vector");
        
        // primera venta de la clase Vector:
        // crea un vector sin especificar tamao
        Vector miVector = new Vector();
        
        // dos objetos de distinto tipo
        String str = new String("ABC");
        int i2 = 5;
        
        // segunda ventaja de la clase Vector
        // se aade un elemento String
        miVector.addElement(str);
        // se aade un elemento de otro tipo
        miVector.addElement(i2);
        
        // recuperar los datos
        for (Object o: miVector)
            System.out.println(o.toString());
        
        // Pero para recuperar los datos
        // tenemos que saber a qu tipo
        // pertenecen
        str = (String) miVector.elementAt(0);
        i2 = (Integer) miVector.elementAt(1);
        
        
        // interfaz Enumeration
        Enumeration e = miVector.elements();
        
        // iteracin por toda la enumeracin
        while(e.hasMoreElements())
        {
            Object o1 = (Object) e.nextElement();
            System.out.println("Objeto de miVector:" + o1.toString());
        }
        
        
         // clase StringTokenizer
        StringTokenizer st = new StringTokenizer("Cantando bajo la lluvia"," ", true);
        
        // iteracin por toda la enumeracin
        while(st.hasMoreElements())        
            System.out.println("Palabra :" + st.nextToken());
         
        
        System.out.println("Este libro es \n sobre Java");
        System.out.println("Un carcter Unicode \t\u0041" );
    }
    
}
