/*
 * Ejemplo1304List.java
 *
 * Created on 1 de mayo de 2006, 13:28
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
/**
 *
 * @author Administrador
 */
public class Ejemplo1304List extends JFrame{
    
    // se permiten selecciones mltiples
    List miLista = new List(4,true);
    
    // botn para visualizar los elementos seleccionados
    Button btn = new Button("Que hay seleccionado?");
    
    // botn para eliminar los elementos seleccionados
    Button btnDel = new Button("Eliminar los elementos seleccionados");
    
    // botn para restaurar los elementos eliminados
    // en la ltima eliminacin
    Button btnUndo = new Button("Deshacer ltima eliminacin");
    
    // para escribir texto del evento clic
    Label lbl1 = new Label();
    
    // para escribir texto desde el evento ItemEvent
    Label lbl2 = new Label();
    
    // lista de elementos eliminados
    String str[];
    
    /** Creates a new instance of Ejemplo1304List */
    public Ejemplo1304List() {
        
        super("Ejemplo1304 List");
        
        Container cp = getContentPane();
        cp.setPreferredSize(new Dimension(350,200));
        
        // se crea el gestor de distribucin
        // seis filas y una columna
        GridLayout bLay = new GridLayout(6,1);
        cp.setLayout(bLay);
        
        // lista desplegable (List)
        miLista.addItem("Uno");
        miLista.addItem("Dos");
        miLista.addItem("Tres");
        miLista.addItem("Cuatro");
        miLista.addItem("Cinco");
        
        // crea un gestor de escucha de eventos de item
        miItemListener lItem = new miItemListener();
        
        // lo aade al objeto List
        miLista.addItemListener(lItem);
        
        // aade al contenedor los componentes
        cp.add(miLista);
        cp.add(lbl1);
        cp.add(btn);
        cp.add(lbl2);
        cp.add(btnDel);
        cp.add(btnUndo);
        
        // el botn de recuperacin nace
        // deshabilitado
        btnUndo.setEnabled(false);
        
        // aade un gestor de escucha
        // para el botn para visualizar
        // los elementos seleccionados
        btn.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                // funcin que se llama
                // al hacer clic en el botn
                btn_clic(e);
            }
        });
        
        // aade un gestor de escucha
        // para el botn de eliminacin
        // de los elementos seleccionados
        btnDel.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                // funcin que se llama
                // al hacer clic en el botn
                btnDel_clic(e);
            }
        });
        
        // aade un gestor de escucha
        // para el botn de deshacer
        // la ltima eliminacin
        btnUndo.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                // funcin que se llama
                // al hacer clic en el botn
                btnUndo_clic(e);
            }
        });
        // visualizar la ventana
        super.pack();
        setVisible(true);
        
        
    }
    
    void btn_clic(ActionEvent e) {
        // se responde al evento clic del botn
        // de visualizacin de los elementos seleccionados
        
        // se obtienen los elementos seleccionados
        String str[] = miLista.getSelectedItems();
        String strSel = "";
        
        // se obtiene una cadena con el
        // contenido de los elementos
        for (String x : str)
            strSel = strSel + " " + x;
        
        // se muestran en la etiqueta
        lbl1.setText(strSel);
        
    }
    void btnDel_clic(ActionEvent e) {
        // se responde al evento clic
        // del botn de eliminacin de
        // los elementos seleccionados
        
        // se obtienen los elementos seleccionados
        str = miLista.getSelectedItems();
        
        // se obtiene una cadena con el
        // contenido de los elementos
        // eliminados
        for (String x : str){
            miLista.remove(x);
        }
        
        // se muestran en la etiqueta
        // la cantidad de elementos eliminados
        lbl2.setText("Elementos eliminados:" + str.length);
        btnUndo.setEnabled(true);
        
    }
    void btnUndo_clic(ActionEvent e) {
        // se responde al evento clic
        // del botn de deshacer
        
        
        // se obtiene una cadena con el
        // contenido de los elementos
        // y los eliminamos
        for (String x : str){
            miLista.add(x);
        }
        
        // se muestran en la etiqueta
        // la cantidad de elementos eliminados
        lbl2.setText("Elementos recuperados:" + str.length);
        btnUndo.setEnabled(false);
        
    }
    
    class miItemListener implements ItemListener {
        public void itemStateChanged(ItemEvent e) {
            // cada vez que cambia el estado de los elementos
            // se genera este evento
            
            // se obtienen los elementos seleccionados
            String str[]= miLista.getSelectedItems();
            String strSel = "";
            
            // se obtiene una cadena con el
            // contenido de los elementos
            for (String x : str)
                strSel = strSel + " " + x;
            
            // se muestran en la etiqueta
            lbl2.setText(strSel);
        }
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Ejemplo1304List();
    }
    
}
