/*
 * Ejemplo1305Scrollbar.java
 *
 * Created on 1 de mayo de 2006, 16:19
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
/**
 *
 * @author Administrador
 */
public class Ejemplo1305Scrollbar extends JFrame{
    
    // Scrollbar
    Scrollbar scb = new Scrollbar(Scrollbar.HORIZONTAL, 10, 5, 1 ,100);
    
    // dos etiquetas para mostrar
    // el valor actual de la barra
    // y elmensaje de advertencia
    Label lbl1 = new Label("");
    Label lbl2 = new Label("5");
    
    
    /** Creates a new instance of Ejemplo1305Scrollbar */
    public Ejemplo1305Scrollbar() {
        super("Ejemplo1305 Scrollbar");
        
        Container cp = getContentPane();
        cp.setPreferredSize(new Dimension(250,100));
        
        // se crea el gestor de distribucin
        // tres filas y una columna
        GridLayout bLay = new GridLayout(3,1);
        cp.setLayout(bLay);
        
        // crea un gestor de escucha de eventos de scroll
        miEscuchaAjuste lAjuste = new miEscuchaAjuste();
        
        // lo aade al objeto Scrollbar
        scb.addAdjustmentListener(lAjuste);
        
        // configura la barra de deslizamiento
        // cada clic en la barra cambia 5 unidades
        scb.setUnitIncrement(5);
        
        
        // aade los componentes al contenedor
        cp.add(scb);
        cp.add(lbl1);
        cp.add(lbl2);
     
        // visualizar la ventana
        super.pack();
        setVisible(true);
    }
    
     class miEscuchaAjuste implements AdjustmentListener {
        public void adjustmentValueChanged(AdjustmentEvent e) {
            // cada vez que cambia el ajuste de la barra   
            // se genera este evento
            
            Integer i = scb.getValue();
            lbl1.setText("Valor actual:" + i.toString());
            
            lbl2.setText("-- Dentro de rango vlido --");
            if ((scb.getValue() < 20) || (scb.getValue() > 80)) {
                lbl2.setText("*** Fuera de rango correcto! ***"); 
            }
  
        }
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Ejemplo1305Scrollbar();
    }
    
}
