/*
 * Ejemplo1306TextField.java
 *
 * Created on 1 de mayo de 2006, 19:12
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 *
 * @author Administrador
 */
public class Ejemplo1306TextField extends JFrame {
    // TextField
    TextField txtf1 = new TextField();
    
    // TextField
    // un constructor con lmite de columnas
    TextField txtf2 = new TextField(5);
    
    // TextField
    // un constructor con texto y lmite de columnas
    TextField txtf3 = new TextField("Introducir el nombre:", 15);
    
    
    // dos etiquetas para mostrar
    // el valor actual de la barra
    // y elmensaje de advertencia
    Label lbl1 = new Label("");
    Label lbl2 = new Label("5");
    
    /** Creates a new instance of Ejemplo1306TextField */
    public Ejemplo1306TextField() {
        
        super("Ejemplo1306TextField");
        
        Container cp = getContentPane();
        cp.setPreferredSize(new Dimension(350,100));
        
        // se crea el gestor de distribucin
        // seis filas y una columna
        GridLayout bLay = new GridLayout(6,1);
        cp.setLayout(bLay);
        
        // crea un gestor de escucha de eventos de accin
        // en este caso, detectar la tecla Intro en el
        // cuadro de texto txtf1
        miEscuchaAccin lAccin = new miEscuchaAccin();
        
        // lo aade al objeto txtf1
        txtf1.addActionListener(lAccin);
        
        // crea un gestor de escucha de eventos de teclado
        //  en el cuadro de texto txtf1
        miEscuchaTeclado lTeclado = new miEscuchaTeclado();
        
        // lo aade al objeto txtf1
        txtf1.addActionListener(lAccin);
        txtf1.addKeyListener(lTeclado);
        
        // aade los componentes al contenedor
        cp.add(txtf1);
        cp.add(txtf2);
        cp.add(txtf3);
        cp.add(lbl1);
        cp.add(lbl2);
        
        // visualizar la ventana
        super.pack();
        setVisible(true);
    }
    
    class miEscuchaAccin implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            // cada vez que hay una accin en el TextField
            // se genera este evento
            
            lbl1.setText("Evento de accin tecla Intro");
            
        }
        
    }
    class miEscuchaTeclado extends KeyAdapter  implements KeyListener {
        public void keyPressed(KeyEvent e) {
            // cada vez que hay una entrada de teclado en el TextField
            // se genera este evento
            
            lbl2.setText("Evento de teclado:" + e.getKeyCode());
        }
        
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Ejemplo1306TextField();
    }
    
}