/*
 * Ejemplo1307TextArea.java
 *
 * Created on 1 de mayo de 2006, 19:12
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 *
 * @author Administrador
 */
public class Ejemplo1307TextArea extends JFrame {
    // TextArea
    TextArea txta = new TextArea("TextArea:", 4, 40);
    
    // mensaje del evento
    Label lbl1 = new Label("");
    
    /** Creates a new instance of Ejemplo1307TextArea */
    public Ejemplo1307TextArea() {
        super("Ejemplo1307TextArea");
        
        Container cp = getContentPane();
        cp.setPreferredSize(new Dimension(350,100));
        
        // se crea el gestor de distribucin
        // dos filas y una columna
        GridLayout bLay = new GridLayout(2,1);
        cp.setLayout(bLay);
        
        // crea un gestor de escucha de eventos de teclado
        //  en el cuadro de texto txtf1
        miEscuchaTeclado lTeclado = new miEscuchaTeclado();
        
        // lo aade al objeto txta
        txta.addKeyListener(lTeclado);
        
        // al texto que utilizamos en el constructor
        // de TextArea lo reemplazamos por este
        // obsrvese que esto no genera eventos
        // de teclado
        txta.replaceRange("ste texto es nuevo", 0, 8);
        
        // despus le aadimos esto
        // obsrvese que esto no genera eventos
        // de teclado
        txta.append(" y ste se aade luego.");
        
        // despus le insertamos esto
        // en la primera posicin (0)
        // obsrvese que esto tampoco genera eventos
        // de teclado
        txta.insert("insercin:",0);
        
        // aade los componentes al contenedor
        cp.add(txta);
        cp.add(lbl1);
        
        // visualizar la ventana
        super.pack();
        setVisible(true);
    }
    
    class miEscuchaTeclado extends KeyAdapter  implements KeyListener {
        public void keyPressed(KeyEvent e) {
            // cada vez que hay una entrada de teclado en el TextArea
            // se genera este evento
            
            lbl1.setText("Evento de teclado:" + e.getKeyCode());
        }
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Ejemplo1307TextArea();
    }
    
}