/*
 * Ejemplo1401JButton.java
 *
 * Created on 5 de mayo de 2006, 17:34
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *
 * @author Administrador
 */
public class Ejemplo1401JButton extends JFrame{
    
    // utilizaremos un gestor de distribucin
    // de tipo BorderLayout
    BorderLayout bl1 = new BorderLayout();
    
    // una interfaz con cinco botones
    // las imgenes se obtienen al crear el objeto
    JButton btnPlay = new JButton(new ImageIcon("G:\\imagen\\Button-play.gif"));
    JButton btnPrev = new JButton(new ImageIcon("G:\\imagen\\Button-prev.gif"));
    JButton btnNext = new JButton(new ImageIcon("G:\\imagen\\Button-next.gif"));
    JButton btnLast = new JButton(new ImageIcon("G:\\imagen\\Button-last.gif"));
    JButton btnStop = new JButton(new ImageIcon("G:\\imagen\\Button-stop.gif"));
    
    
    /** Creates a new instance of Ejemplo1401JButton */
    public Ejemplo1401JButton() {
        super.setTitle("Ejemplo 1401 JButton");
        
        // separacin entre los componentes en la interfaz
        // Borderlayout
        bl1.setHgap(15);
        bl1.setVgap(15);
        
        // asignar el gestor al contenedor
        this.getContentPane().setLayout(bl1);
        
        // Mnemnicos de los botones
        // es la letra que se subraya en el botn
        btnPlay.setMnemonic('R');
        btnPrev.setMnemonic('A');
        btnStop.setMnemonic('D');
        btnNext.setMnemonic('S');
        btnLast.setMnemonic('');
        
        // textos en la cara del ratn
        btnPlay.setText("Reproducir");
        btnPrev.setText("Anterior");
        btnNext.setText("Siguiente");
        btnLast.setText("ltima");
        btnStop.setText("Detener");
        
        
        // posicin del texto
        // botn reproducir
        // el texto debajo del dibujo
        btnPlay.setVerticalTextPosition(SwingConstants.BOTTOM);
        btnPlay.setHorizontalTextPosition(SwingConstants.CENTER);
        
        // el texto a la izquierda del dibujo
        btnLast.setHorizontalTextPosition(SwingConstants.LEFT);
        
        // botn detener
        // el texto encima del dibujo
        btnStop.setVerticalTextPosition(SwingConstants.TOP);
        btnStop.setHorizontalTextPosition(SwingConstants.CENTER);
        // botn Detener inicia deshabilitado
        // el botn se vuelve gris
        btnStop.setEnabled(false);
        
        // aadimos los botones
        // orientacin BorderLayout
        this.getContentPane().add(btnPlay, bl1.NORTH);
        this.getContentPane().add(btnPrev, bl1.WEST);
        this.getContentPane().add(btnNext, bl1.CENTER);
        this.getContentPane().add(btnLast, bl1.EAST);
        this.getContentPane().add(btnStop, bl1.SOUTH);
        
        
        // super
        super.pack();
        // mostrar la ventana
        this.setVisible(true);
        
        // creamos los gestores de eventos de los botones
        // gestor del evento clic en botn Reproducir
        btnPlay.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e){
                // el botn se vuelve gris
                 // y queda desactivado
                // si est desactivado no
                // recibir ms eventos clic
                btnPlay.setEnabled(false);
                
                // borramos el borde
                btnPlay.setBorderPainted(false);
                
                // el botn se activa
                btnStop.setEnabled(true);
            }});

            // gestor del evento clic en botn Detener
            btnStop.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e){
                    // el botn se vuelve gris
                    // y queda desactivado
                    btnStop.setEnabled(false);
                    
                    // el botn se activa
                 btnPlay.setEnabled(true);
                    
                    // redibujar el borde
                    btnPlay.setBorderPainted(true);
                }});
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Ejemplo1401JButton();
    }
    
}
