/*
 * Ejemplo1403JToggle.java
 *
 * Created on 5 de mayo de 2006, 20:19
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 *
 * @author Administrador
 */
public class Ejemplo1403Toggle extends JFrame implements ActionListener{
    GridLayout gl1 = new GridLayout(4,1);
    JToggleButton tb1 = new JToggleButton();
    JToggleButton tb2 = new JToggleButton();
    ButtonGroup bg = new ButtonGroup();
    JLabel lbl = new JLabel();
    
    /** Creates a new instance of Ejemplo1403JToggle */
    public Ejemplo1403Toggle() {
        super.setTitle("Ejemplo JToggleButton");
        
        // se asigna el gestor de distribucin
        // al contenedor
        this.getContentPane().setLayout(gl1);
        
        // asignar texto a los botones de opcin
        // usamos setActionCommand para
        // utilizar el campo en el evento
        
        // ste es el texto de la opcin
        tb1.setText("Imagen y texto");
        // este valor se usa en el evento
        // para colocarlo en la retiqueta lbl
        tb1.setActionCommand("**Imagen y texto**");
        
        tb2.setText("Imagen slo");
        tb2.setActionCommand("**Imagen slo**");
        
       
        // uno de los botones est seleccionado
        tb1.setSelected(true);
        
        // aade los botones al grupo
        bg.add(tb1);
        bg.add(tb2);

        
        // aade los componentes al contenedor
        this.getContentPane().add(lbl);
        this.getContentPane().add(tb1);
        this.getContentPane().add(tb2);
        
        
        
        // registra los agentes de escucha
        // todas las acciones se centralizan en
        // el frame que implementa ActionListener
        // Eventos de los botones de opcin
        tb1.addActionListener(this);
        tb2.addActionListener(this);
        
        super.pack();
        // se visualiza la ventana
        this.setVisible(true);
        
        
    }
    
    public void actionPerformed(ActionEvent e) {
        // un nico actionPerformed ya que pertenece
        // a la clase que implementa ActionListener
        
        //getActionCommand nos permite saber
        // de dnde viene el evento
        
        // se escribe la etiqueta albl
        lbl.setText(e.getActionCommand());
        
        // tambin
        // se puede consultar si un botn est seleccionado
        if (tb1.isSelected()) lbl.setText("Opcin 1");
        
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Ejemplo1403Toggle();
    }
    
}
