/*
 * Ejemplo1502Thread.java
 *
 * Created on 8 de mayo de 2006, 19:48
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author Administrador
 */
public class Ejemplo1502Thread implements Runnable {
    // el mismo ejemplo que Ejemplo1501Thread
    // pero sin derivar de Thread sino
    // que implementando Runnable
    // el efecto es el mismo
    
    // propiedades de la clase
    // msg mensaje
    // lContar para contar el bucle
    // lSleep para personalizar el tiempo
    // suspensin del subproceso
    
    String msg;
    long lContar;
    int lSleep;
    
    // lSumar pertenece al objeto no al
    // ejemplar o instancia
    static long lSumar;
    
    // subproceso
    Thread t;
    
    /** Creates a new instance of Ejemplo1502Thread */
    public Ejemplo1502Thread(String nombre, long c, int tiempo) {
        
        // constructor del objeto
        lContar = c;
        msg = nombre;
        lSleep = tiempo;
        
        // tambin crea el subproceso
        // y lo inicia
        t = new Thread(this);
        t.start();
        
        // avisa que se est ejecutando
        // comprobar que se inician ordenadamente
        // pero terminarn desordenadamente dado
        // que tienen diferentes tiempos de sleep
        System.out.println(nombre + ": ejecutando Thread");
        
    }
    // hay que implementar el mtodo run()
    public void run() {
        
        // el bucle lContar se hace
        // desde lContar hasta cero
        while(lContar-- > 0 ){
            try {
                // se suma en la variable de clase lSumar
                lSumar++;
                t.sleep(lSleep);
                
                
            } catch (InterruptedException e) {
                return;
                
            }
        }
        System.out.println(msg + ": finalizado, estado de la suma lSumar: " + lSumar);
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // se generan cuatro ejemplares
        // cada uno se ejecutar en un subproceso diferente
        // y con tiempos de espera diferentes
        // el tiempo es en milisegundos
        new Ejemplo1502Thread("Primer subproceso :", 100, 50);
        new Ejemplo1502Thread("Segundo subproceso :", 100, 12);
        new Ejemplo1502Thread("Tercer subproceso :", 100, 100);
        new Ejemplo1502Thread("Cuarto subproceso :", 100, 20);
    }
    
}
