/*
 * Ejemplo1503Thread.java
 *
 * Created on 8 de mayo de 2006, 19:48
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author Administrador
 */
public class Ejemplo1503Thread extends Thread {
    // en este ejemplo se detiene un subproceso con
    // la ayuda de una variable detener
    // no se utiliza el mtodo stop() porque
    // no es seguro
    
    // propiedades de la clase
    // msg mensaje
    // lContar para contar el bucle
    // lSleep para personalizar el tiempo
    // suspensin del subproceso
    String msg;
    long lContar;
    int lSleep;
    
    // variable de clase
    static long lSumar;
    
    // variable para detener el subproceso
    protected  boolean detener = false;
    
    /** Creates a new instance of Ejemplo1503Thread */
    public Ejemplo1503Thread(String nombre, long c, int tiempo) {
        
        // constructor del objeto
        lContar = c;
        msg = nombre;
        lSleep = tiempo;
        
  
        // avisa que se est ejecutando
        // comprobar que se inician ordenadamente
        // pero terminarn desordenadamente dado
        // que tienen diferentes tiempos de sleep
        System.out.println(nombre + ": ejecutando Thread");
        
    }
    // hay que implementar el mtodo run()
    public void run() {
        // el bucle lContar se hace
        // desde lContar hasta cero
        while(lContar-- > 0 && !detener){
            try {
                
                Thread.sleep(lSleep);
                
                // cuando lSumar llega a 5
                // se detiene el subproceso vigente
                // el resto seguir
                if (lSumar == 5) detener();
                
                // se suma en la variable de clase lSumar
                lSumar++;
                
                // situacin del contador
                // y del campo detener
                System.out.println(msg + ":  lSumar: " + lSumar + " detener " + detener);
                
            } catch (InterruptedException e) {
                return;
                
            }
        }
        System.out.println(msg + ": finalizado, estado de la suma lSumar: " + lSumar);
        detener = false;
    }
    public void detener() {
        detener = true;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // se generan cuatro ejemplares
        // cada uno se ejecutar en un subproceso diferente
        // y con tiempos de espera diferentes
        // el tiempo es en milisegundos
        new Ejemplo1503Thread("Primer subproceso :", 4, 50).start();
        new Ejemplo1503Thread("Segundo subproceso :", 4, 12).start();
        new Ejemplo1503Thread("Tercer subproceso :", 4, 100).start();
        new Ejemplo1503Thread("Cuarto subproceso :", 4, 20).start();
    }
    
}
