/*
 * Ejemplo1602DB.java
 */
import java.sql.*;
/**
 *
 * @author Administrador
 */
public class Ejemplo1602DB {
    // en este ejemplo se recuperan
    // las filas del resultSet
    // yv se imprimen
    Connection cnn;
    
    /** Creates a new instance of Ejemplo1602DB */
    public Ejemplo1602DB() {
        // en este caso hay un origen de sistema
        // en ODBC con el nombre Licencias
        
        // cadena de conexin
        String url ="jdbc:odbc:Licencias";
        
        // bloque try/catch para detectar
        // excepciones de conexin
        try {
            // verifica la existencia de la clase
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            
            // establece la conexin utilizando
            // el string url, en este caso,
            // no requiere usuario nin contrasea
            cnn = DriverManager.getConnection(url ,"","");
            
            acceso();
            
            // cierre de conexin
            cnn.close();
            System.out.println("OK: conexin cerrada");
        } catch (Exception e) {
            System.out.println("KO: no se pudo conectar " + e);
            
            
        }
        
    }
    public void acceso(){
        try{
            String sql= "SELECT * FROM licencias";
            System.out.println("Formato nativo " + cnn.nativeSQL(sql));
            Statement stm = cnn.createStatement();
            
            // ejecucin de la consulta
            // se obtiene el conjunto de resultados
            ResultSet rs = stm.executeQuery(sql);
            
            // se hace un bucle por todo el conjunto
            // de resultados
            // el objeto resultSet tiene mtodos
            // para navegar por el conjunto
            while(rs.next()){
                // se recuperan dos campos String
                // y un campo int
                int num = rs.getInt(1);
                String email = rs.getString(2);
                String nombre = rs.getString(3);
                
                // se imprimen los resultados
                System.out.println("Nmero: " + num + " Email: " + email + " Nombre: " + nombre);
            }
            // cerrar el resultSet
            rs.close();
            
            System.out.println("OK acceso sql ");
        } catch (Exception e) {
            System.out.println("error en acceso sql " + e);
        }
    }
    public static void main(String args[]){
        new Ejemplo1602DB();
    }
}
