/*
 * Ejemplo1603Update.java
 */
import java.sql.*;
/**
 *
 * @author Administrador
 */
public class Ejemplo1603Update {
    // en este ejemplo se actualizan
    // algunas filas del resultSet
    //  
    Connection cnn;
    
    /** Creates a new instance of Ejemplo1603Update */
    public Ejemplo1603Update() {
        // en este caso hay un origen de sistema
        // en OUpdateC con el nombre Licencias
        
        // cadena de conexin
        String url ="jdbc:odbc:FICHERO";
        
        // bloque try/catch para detectar
        // excepciones de conexin
        try {
            // verifica la existencia de la clase
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            
            // establece la conexin utilizando
            // el string url, en este caso,
            // no requiere usuario nin contrasea
            cnn = DriverManager.getConnection(url ,"","");
            
            acceso();
            
            // cierre de conexin
            cnn.close();
            System.out.println("OK: conexin cerrada");
        } catch (Exception e) {
            System.out.println("KO: no se pudo conectar " + e);
            
        }
        
    }
    public void acceso(){
        try {
            PreparedStatement stm= cnn.prepareStatement("UPDATE Subtema SET Tema = ? WHERE Subtema = ?");
            
            // se asigna valores
            // a los parmetros de
            // la sentencia sql
            
            // primer campo email = ?
            stm.setString(1, "tres puntos");
            
            // segundo campo nombre = ?
            stm.setString(2, "imposible");
            
            // ejecucin de la actualizacin
            int rs =stm.executeUpdate();
            
            // en rs queda el valor de la cantidad de filas
            // afectadas
            System.out.println("Cantidad de filas afectadas: " + rs);
            
            // cerrar la sentencia preparada
            stm.close();
            
                       
            System.out.println("OK acceso sql ");
            
        } catch (Exception e) {
            System.out.println("error en acceso sql " + e);
        }
    }
    
    public static void main(String args[]){
        new Ejemplo1603Update();
    }
}
