/*
 * Ejemplo1803Client.java
 */
import java.net.*;
import java.io.*;
/**
 *
 * @author Administrador
 */
public class Ejemplo1803Client {
    InputStreamReader sr;
    OutputStreamWriter sw;
    DataInputStream entrada = new DataInputStream(System.in);
    boolean  nofin = true;
    String str;
    
    /** Creates a new instance of Ejemplo1803Client */
    public Ejemplo1803Client() {
        try {
            // programa Ejemplo1803Client
            // programa cliente que se conecta
            // con un servidor y le enva datos
            // con el mtodo write del socket
            
            // creacin del socket
            Socket skt = new Socket("172.26.0.8",3203);
            
            // definicin del flujo de entrada
            sr = new InputStreamReader(skt.getInputStream());
            
            // definicin del flujo de salida
            sw = new OutputStreamWriter(skt.getOutputStream());
            
            do{
                try {
                    // bucle de peticiones y respuestas
                    System.out.println("Entrar datos a transmitir al servidor");
                    // se lee la entrada de teclado y se recortan espacios
                    str = entrada.readLine().trim();
                    
                    // si se introduce FIN
                    // se termina el programa Cliente
                    if (str.compareToIgnoreCase("FIN") == 0) {
                        nofin = false;
                    }
                    
                    // mtodo envo()
                    this.envo(str);
                    System.out.println("datos enviados:" + str);
                    
                    // respuesta del servidor
                    str =this.recepcin();
                    System.out.println("Recibido desde el servidor:" + str);
                    
                    
                } catch (IOException e) {
                    System.out.println("error de conexin " + e);
                }
              
                
            } while(nofin);
            // cierre de socket y flujos de datos
            skt.close();
            sr.close();
            sw.close();
            
        } catch (IOException e) {
            System.out.println("No pudo crear el socket");
        }
        
    }
    public void envo(String str)  throws IOException {
        // mtodo de envo de datos desde el cliente al servidor
        
        // se escribe el flujo de datos en la salida
        // datos que van al servidor
        sw.write(str);
        
        // se fuerza el envo del flujo
        sw.flush();
    }
    public String recepcin() throws IOException{
        char [] texto = new char[256];
        
        // lectura desde el servidor
        sr.read(texto, 0,255);
        
        // devuelve la cadena leda
        return(new String(texto).trim() );
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Ejemplo1803Client();
    }
    
}
