/*
 * Ejemplo1804ServerThread.java
 *
 */
import java.net.*;
import java.io.*;
/**
 *
 * @author Administrador
 */
public class Ejemplo1804ServerThread {
    
    ServerSocket server;
    Socket client;
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Ejemplo1804ServerThread();
    }
    
    /** Creates a new instance of Ejemplo1804ServerThread */
    public Ejemplo1804ServerThread() {
        int puerto = 3203;
        try {
            // Creacin del socket
            System.out.println("Creando el socket para el servidor...");
            
            // creacin de un servidor en el puerto
            server = new ServerSocket(puerto);
            
            
            System.out.println("Servidor a la espera de peticiones de los clientes...");
            
            // bucle de peticiones de clientes y respuestas del servidor
            while((client=server.accept()) != null) {
                
                // crea el objeto SubProceso y lo inicia  
                new SubProceso(client).start();
                
            }
        } catch (IOException e) {
            System.out.println("No puedo utilizar el puerto " + puerto + " excepcin " + e);
        }
        
    }
    
    // clase derivada de Thread
    class SubProceso extends Thread {
        Socket client;
        InputStreamReader sr;
        OutputStreamWriter sw;
        
        SubProceso(Socket s){
            client = s;
        }
        
        public void run(){
            System.out.println("Se inicia el conector en un subproceso independiente");
            try {
                // qu cliente me enva informacin?
                System.out.println(("peticin desde " + client.getInetAddress()));
                
                // definicin del flujo de entrada
                sr = new InputStreamReader(client.getInputStream());
                
                // definicin del flujo de salida
                sw = new OutputStreamWriter(client.getOutputStream());
                char[] msg = new char[256];
                
                // lectura de lo que llega desde el cliente
                sr.read(msg, 0, 255);
                
                // convertir a String
                String msgs = new String(msg).trim();
                
                // se reenva la respuesta al cliente
                sw.write("Servidor recibi mensaje: " + msgs);
                sw.flush();
                // cierres
                sr.close();
                sw.close();
            } catch (IOException e) {
                System.out.println("Error de IO en socket");
            }
            
        }
    }
    
}

