/*
 * Main.java
 *
 * Created on 20 de abril de 2006, 23:51
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package cap09b;
import org.ed.mibib.*;

/**
 *
 * @author Administrador
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // Ejemplos de uso de la clase StringBuffer
        
        // constructores
        System.out.println("Uso de constructores StringBuffer");
        StringBuffer strb1 = new StringBuffer();
        // la respuesta ser 0
        System.out.println("1. Longitud de la secuencia de caracteres:" + strb1.length());
        // la respuesta ser 16
        System.out.println("1. Capacidad de la secuencia de caracteres:" + strb1.capacity());
        
        // creacin con una capacidad personalizada
        StringBuffer strb2 = new StringBuffer(64);
        // la respuesta ser 0
        System.out.println("2. Longitud de la secuencia de caracteres:" + strb2.length());
        // la respuesta ser 64
        System.out.println("2. Capacidad de la secuencia de caracteres:" + strb2.capacity());
        
        // creacin a partir de una cadena
        StringBuffer strb3 = new StringBuffer("abcd");
        // la respuesta ser 4
        System.out.println("3. Longitud de la secuencia de caracteres:" + strb3.length());
        // la respuesta ser 16 + 4
        System.out.println("3. Capacidad de la secuencia de caracteres:" + strb3.capacity());
        
        // append
        System.out.println("Uso de append");
        // aadido de un dato a la secuencia de caracteres
        StringBuffer strb4 = new StringBuffer("abcd");
        // aade un booleano
        strb4.append(true);
        // queda abcdtrue
        System.out.println("append boolean:" + strb4);
        
        // aade un long
        strb4.append(500L);
        // queda abcdtrue500
        System.out.println("append long:" + strb4);
        
        // aade un double
        strb4.append(200.567D);
        // queda abcdtrue500200.567
        System.out.println("append double:" + strb4);
        
        // aade un int
        strb4.append(3333);
        // queda abcdtrue500200.5673333
        System.out.println("append int:" + strb4);
        
        // aade un objeto
        RealEjemplo01 x = new RealEjemplo01();
        strb4.append(x);
        // queda abcdtrue500200.5673333org.ed.mibib.RealEjemplo01@7d772e
        System.out.println("append objeto:" + strb4);
        
        // capacity
        System.out.println("Uso de capacity");
        System.out.println("capacity :" + strb4.capacity());
        System.out.println("length :" + strb4.length());
        
        // charAt
        System.out.println("Uso de charAt");
        System.out.println("charAt posicin 3 :" + strb4.charAt(3));
        
        // delete
        System.out.println("Uso de delete");
        // crea otro objeto StringBuffer con un substring
        System.out.println("delete strb4 tiene una longitud de :" + strb4.length());
        // al nuevo StringBuffer lo crearemos a partir de strb4 pero
        // le quitaremos desde la pos. 7 hasta la posicin 57
        // 57 no existe ya que la longitud es 55, por lo que la ltima
        // posicin es length() -1 = 54
        StringBuffer strb5 = strb4.delete(7, 57);
        // la respuesta ser abcdtru
        System.out.println("delete strb5 es :" + strb5);
        // veamos cmo queda la capacidad y la longitud
        System.out.println("capacity de strb5 :" + strb5.capacity());
        System.out.println("length de strb5 :" + strb5.length());
        
        // deleteCharAt
        System.out.println("Uso de deleteCharAt");
        StringBuffer strb6 = strb5.deleteCharAt(0);
        // la respuesta ser bcdtru
        System.out.println("delete strb6 es :" + strb6);
        // veamos cmo cambia la capacidad (no cambia) y la longitud
        System.out.println("capacity de strb6 :" + strb6.capacity());
        System.out.println("length de strb6 :" + strb6.length());
        
        // ensureCapacity
        System.out.println("Uso de ensureCapacity");
        // cambiar la capacidad mnima a 100
        strb6.ensureCapacity(100);
        System.out.println("1. ensureCapacity de strb6 :" + strb6.capacity());
        // modifcamos strb6
        strb6.delete(2, 5);
        // cmo queda la capacidad? No cambia.
        System.out.println("2. ensureCapacity de strb6 :" + strb6.capacity());
        
        
        // insert
        System.out.println("Uso de insert");
        // inserta el argumento en un punto de la secuencia
        // StringBuffer
        StringBuffer strb7 = new StringBuffer("a b c d ");
        // la respuesta ser a b c d
        System.out.println("1. antes de insertar strb7 :" + strb7);
        // este mtodo modifica el StringBuffer de origen
        // y el resultado lo asigna en strb8
        // inserta un double
        StringBuffer strb8 = strb7.insert(1,200D);
        // la respuesta ser a200.0 b c d
        System.out.println("1. insert double de strb7 :" + strb7);
        System.out.println("1. insert double de strb8 :" + strb8);
        
        // inserta una matriz char en pos. 1
        // recordar que la primera posicin se numera con cero
        char ch[] ={ 65, 66}; // equivale a: A B
        strb7.insert(1,ch);
        // la respuesta ser aAB200.0 b c d
        System.out.println("2. inserta matriz char en strb7 :" + strb7);
        
        // inserta un long en pos. 1
        // recordar que la primera posicin se numera con cero
        strb7.insert(1,3999L);
        // la respuesta ser a3999AB200.0 b c d
        System.out.println("3. inserta long en strb7 :" + strb7);
        
        // inserta un float pos. 1
        // recordar que la primera posicin se numera con cero
        strb7.insert(1,250.88);
        // la respuesta ser a250.883999AB200.0 b c d
        System.out.println("4. inserta float en strb7 :" + strb7);
        
        
        // inserta una matriz
        //pero slo una parte de la matriz float pos. 1
        // recordar que la primera posicin se numera con cero
        char ch2[] ={ 65, 66, 67, 68, 69, 70}; // equivale a: ABCDEFG
        StringBuffer strb9 = new StringBuffer();
        strb9.insert(0,"INICIO:");
        // slo inserta CDEF
        strb9.insert(7,ch2, 2, 4);
        // la respuesta ser INICIO:CDEF
        System.out.println("5. inserta ch2 strb9 :" + strb9);
        
        // replace
        System.out.println("Uso de replace");
        // reemplaza un texto por otro
        // strb9 es INICIO:CDEF
        strb9.replace(0, 6, "start>");
        // la respuesta ser start>:CDEF
        System.out.println("replace de strb9 :" + strb9);
        
        // reverse
        System.out.println("Uso de reverse");
        // invierte un texto
        // strb9 es start>:CDEF
        strb9.reverse();
        // la respuesta ser FEDC:>trats
        System.out.println("reverse de strb9 :" + strb9);
        
        
        // setCharAt
        System.out.println("Uso de setCharAt");
        // coloca un char en una posicin
        // strb9 es FEDC:>trats
        char ch3 = 65; // es la letra A
        strb9.setCharAt(0, ch3);
        // la respuesta ser AEDC:>trats
        System.out.println("setCharAt de strb9 :" + strb9);
        
        // substring
        System.out.println("Uso de substring");
        // devuelve un objeto String
        // que es una subcadena del objeto StringBuffer
        // strb9 es FEDC:>trats
        // atencin: enn el mtodo se usa
        // la primera posicin de la subcadena
        // contada desde 0 y el segundo argumento es el ndice
        // del final de la subcadena (excluyendolo)
        // si usamos (1,1) el resultado es vaco
        
        String str1 =  strb9.substring(1,1);
        // la respuesta ser  vaca
        System.out.println("substring de str1 :" + str1.length());
        
        str1 =  strb9.substring(1,3);
        // la respuesta ser  ED
        System.out.println("substring de str1 :" + str1);
        
        // trimToSize
        System.out.println("Uso de trimToSize");
        // recorta el almacenamiento
        System.out.println("antes del recorte..." + strb9);
        System.out.println("longitud de strb9 :" + strb9.length());
        System.out.println("capacidad de strb9 :" + strb9.capacity());
        strb9.trimToSize();
        System.out.println("despus del recorte...");
        System.out.println("longitud de strb9 :" + strb9.length());
        System.out.println("capacidad de strb9 :" + strb9.capacity());
        
    }
    
}
