/*
 * Ejemplo1202BorderLayout.java
 *
 * Created on 27 de abril de 2006, 12:13
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
/**
 *
 * @author Administrador
 */


public class Ejemplo1202BorderLayout extends JFrame{
    
    JButton btn1;
    JButton btn2;
    JButton btn3;
    JButton btn4;
    JButton btn5;
    JButton btn6;
    
    /** Creates a new instance of Ejemplo1202BorderLayout */
    public Ejemplo1202BorderLayout()  {
        super("BorderLayout");
        
        // el mtodo getContentPane devuelve
        // el objeto contentPane para este frame
        //  El objeto Container es un objeto que puede
        //  contener otros componentes AWT
        Container cp = getContentPane();
        
        // setPreferredSize es un mtodo que proviene
        // de la clase Component
        // que asigna el tamao preferido de este componente
        cp.setPreferredSize(new Dimension(300,200));
        
        // el mtodo setLayout es un mtodo
        // no heredado, es propio de la clase
        // Container
        // define cmo se distribuyen los
        // componentes en el contenedor
        cp.setLayout(new BorderLayout());
        
        // el mtodo add aade un componente
        // al contenedor siguiendo el layout
        // (distribucin definida)
        
        cp.add("North", btn1 = new JButton("Botn 1"));
        cp.add("Center", btn2 = new JButton("Botn 2"));
        cp.add("West", btn3 = new JButton("Botn 3"));
        cp.add("East", btn4 = new JButton("Botn 4"));
        cp.add("South", btn5 = new JButton("Botn 5"));
        
        // qu pasa si hay dos SOUTH?
        cp.add("South", btn6 = new JButton("Botn 6"));
        // respuesta: btn5 queda tapado por btn6
        
        super.pack();
        setVisible(true);
    }
    
    public static void main(String args[]){
        new Ejemplo1202BorderLayout();
    }
}