/*
 * Ejemplo1202GridBagLayout.java
 *
 * Created on 27 de abril de 2006, 12:13
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
/**
 *
 * @author Administrador
 */


public class Ejemplo1202GridBagLayout extends JFrame{
    
    JButton btn1;
    JButton btn2;
    JButton btn3;
    JButton btn4;
    JButton btn5;
    JButton btn6;
    JButton btn7;
    
    /** Creates a new instance of Ejemplo1202GridBagLayout */
    public Ejemplo1202GridBagLayout()  {
        super("GridBagLayout");
        
        // el mtodo getContentPane devuelve
        // el objeto contentPane para este frame
        //  El objeto Container es un objeto que puede
        //  contener otros componentes AWT
        Container cp = getContentPane();
        
        // setPreferredSize es un mtodo que proviene
        // de la clase Component
        // que asigna el tamao preferido de este componente
        cp.setPreferredSize(new Dimension(300,200));
        
        // el mtodo setLayout es un mtodo
        // no heredado, es propio de la clase
        // Container
        // define cmo se distribuyen los
        // componentes en el contenedor
        
        // se crea el objeto GridBagLayout
        GridBagLayout gbl = new GridBagLayout();
        
        // el objeto de las constraints lo
        // complementa
        GridBagConstraints gblc = new GridBagConstraints();
        
        // se asigna el layout al contenedor
        cp.setLayout(gbl);
        
        // Constraints
        // BOTH se utiliza para redimensionar el componente
        // tanto horizontal como verticalmente
        // HORIZONTAL o VERTICAL indica que slo
        // se ocupa la dimensin correspondiente
        gblc.fill = GridBagConstraints.HORIZONTAL;
        
        // weightx especifica cmo distribuir el espacio
        // horizontal extra
        gblc.weightx = 0.0;
        btn1 = new JButton("Botn 1");
        // al objeto GridBagLayout se le signa el 
        // componente y sus constraints
        gbl.setConstraints(btn1, gblc);
        
        // se aade el componente al contenedor
        cp.add(btn1);
        
        
        //este proceso se repite para cada componente
        // lo que vara son las disposiciones
        btn2 = new JButton("Botn 2");
        gbl.setConstraints(btn2, gblc);
        cp.add(btn2);
        
        // REMAINDER especifica que este componente
        // es el ltimo de la columna o de la fila
        gblc.gridwidth = GridBagConstraints.REMAINDER;
        btn3 = new JButton("Botn 3");
        gbl.setConstraints(btn3, gblc);
        cp.add(btn3);
        
        // este componente empieza otra fila
        // pero al quedar como REMAINDER ocupar
        // toda la fila
        btn4 = new JButton("Botn 4");
        gbl.setConstraints(btn4, gblc);
        cp.add(btn4);
        
        // el siguiente componente
        // ocupar dos filas
        gblc.gridheight = 2;
        
        // RELATIVE especifica que este componente
        // se coloca al lado del anterior
        // adems ocupar dos filas
        gblc.gridwidth = GridBagConstraints.RELATIVE;
        btn5 = new JButton("Botn 5");
        gbl.setConstraints(btn5, gblc);
        cp.add(btn5);
        
        // ste es el ltimo de la fila
        gblc.gridwidth = GridBagConstraints.REMAINDER;
        // ocupar slo 1 fila
        gblc.gridheight = 1;
        btn6 = new JButton("Botn 6");
        gbl.setConstraints(btn6, gblc);
        cp.add(btn6);
        
        // mantiene los valores del anterior
        btn7 = new JButton("Botn 7");
        gbl.setConstraints(btn7, gblc);
        cp.add(btn7);
        
        super.pack();
        setVisible(true);
    }
    
    public static void main(String args[]){
        new Ejemplo1202GridBagLayout();
    }
}
