/*
 * Ejemplo1308Panel.java
 *
 * Created on 1 de mayo de 2006, 19:12
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 *
 * @author Administrador
 */
public class Ejemplo1308Panel extends JFrame {
    
    Panel pn1;
    Panel pn2;
    Button btn;
    
    /** Creates a new instance of Ejemplo1308Panel */
    public Ejemplo1308Panel() {
        super("Ejemplo1308Panel");
        
        Container cp = getContentPane();
        cp.setPreferredSize(new Dimension(400,300));
        
        // se crea el gestor de distribucin
        // dos filas y una columna
        GridLayout gLay = new GridLayout(2,1);
        cp.setLayout(gLay);
        
        // Panel 1 con FlowLayout
        FlowLayout fLay = new FlowLayout();
        pn1 = new Panel(fLay);
        // a este botn le daremos la accin de hacer
        // visible/ocultar al panel 2
        btn = new Button("Ocultar el panel 2");
        pn1.add(btn);
        
        // resto de los botones al panel
        pn1.add(new Button("panel 1 botn 2"));
        pn1.add(new Button("panel 1 botn 3"));
        pn1.add(new Label("estoy dentro del panel 1"));
        // aade el panel 1 al contenedor JFrame
        cp.add(pn1);
        
        // Panel con BorderLayout
        BorderLayout bLay = new BorderLayout();
        pn2 = new Panel(bLay);
        pn2.add(new Button("panel 2 botn ESTE"), BorderLayout.EAST);
        pn2.add(new Button("panel 2 botn SUR"), BorderLayout.SOUTH);
        pn2.add(new Button("panel 2 botn NORTE"), BorderLayout.NORTH);
        pn2.add(new Button("panel 2 botn OESTE"), BorderLayout.WEST);
        pn2.add(new Button("panel 2 botn CENTRO"), BorderLayout.CENTER);
        
        // aade el panel 2 al contenedor JFrame
        cp.add(pn2);
        

        // aade un gestor de escucha
        // para el botn btn
      
        btn.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                // funcin que se llama
                // al hacer clic en el botn
                btn_clic(e);
            }
        });
        
        super.pack();
        setVisible(true);
        
    }
    
    void btn_clic(ActionEvent e) {
        // se responde al evento clic del botn
        // btn que controla la visibilidad del panel 2
        if (pn2.isVisible()) {
            pn2.setVisible(false);
            btn.setLabel("Hacer visible al panel 2");
        } else {
            pn2.setVisible(true);
            btn.setLabel("Ocultar el panel 2");
        }
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Ejemplo1308Panel();
    }
    
}
