/*
 * Ejemplo1402JRadio.java
 *
 * Created on 5 de mayo de 2006, 20:19
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 *
 * @author Administrador
 */
public class Ejemplo1402JRadio extends JFrame implements ActionListener{
    GridLayout gl1 = new GridLayout(4,1);
    JRadioButton rb1 = new JRadioButton();
    JRadioButton rb2 = new JRadioButton();
    JRadioButton rb3 = new JRadioButton();
    ButtonGroup bg = new ButtonGroup();
    JLabel lbl = new JLabel();
    
    /** Creates a new instance of Ejemplo1402JRadio */
    public Ejemplo1402JRadio() {
        super.setTitle("Ejemplo Radio Button");
        
        // se asigna el gestor de distribucin
        // al contenedor
        this.getContentPane().setLayout(gl1);
        
        // asignar texto a los botones de opcin
        // usamos setActionCommand para
        // utilizar el campo en el evento
        
        // ste es el texto de la opcin
        rb1.setText("Imagen y texto");
        // este valor se usa en el evento
        // para colocarlo en la retiqueta lbl
        rb1.setActionCommand("**Imagen y texto**");
        
        rb2.setText("Imagen slo");
        rb2.setActionCommand("**Imagen slo**");
        
        rb3.setText("Texto slo");
        rb3.setActionCommand("**slo texto**");
        
        // uno de los botones est seleccionado
        rb1.setSelected(true);
        
        
        // aade los botones al grupo
        bg.add(rb1);
        bg.add(rb2);
        bg.add(rb3);
        
        // aade los componentes al contenedor
        this.getContentPane().add(lbl);
        this.getContentPane().add(rb1);
        this.getContentPane().add(rb2);
        this.getContentPane().add(rb3);
        
        
        
        // registra los agentes de escucha
        // todas las acciones se centralizan en
        // el frame que implementa ActionListener
        // Eventos de los botones de opcin
        rb1.addActionListener(this);
        rb2.addActionListener(this);
        rb3.addActionListener(this);
        
        super.pack();
        // se visualiza la ventana
        this.setVisible(true);
        
        
    }
    
    public void actionPerformed(ActionEvent e) {
        // un nico actionPerformed ya que pertenece
        // a la clase que implementa ActionListener
        
        //getActionCommand nos permite saber
        // de dnde viene el evento
        
        // se escribe la etiqueta albl
        lbl.setText(e.getActionCommand());
        
        // alineacin a la derecha
        lbl.setHorizontalAlignment(SwingConstants.RIGHT);
        
      
        
        
        // tambin
        // se puede consultar si un botn est seleccionado
        if (rb1.isSelected()) lbl.setText("Opcin 1");
        
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Ejemplo1402JRadio();
    }
    
}
