/*
 * Ejemplo1405JTextField.java
 *
 * Created on 6 de mayo de 2006, 9:24
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 *
 * @author Administrador
 */
public class Ejemplo1405JTextField extends JFrame implements KeyListener {
    // implementa KeyListener
    // para recibir eventos de teclado
    
    // constructores de JTextField con texto inicial
    JTextField tf1 = new JTextField("Con texto inicial");
    // 20 columnas
    JTextField tf2 = new JTextField(20);
    // con texto y columnas
    JTextField tf3 = new JTextField("Con texto inicial y columnas", 5);
    // contrasea
    JPasswordField pf1 = new JPasswordField();
    
    // gestor de distribucin
    GridLayout gl = new GridLayout(5,1);
    
    // etqueta
    JLabel lbl = new JLabel("lbl");
    
    /** Creates a new instance of Ejemplo1405JTextField */
    public Ejemplo1405JTextField() {
        super.setTitle("Ejemplo1405 TextField");
        
        // asignar tamao a la ventana
        this.getContentPane().setPreferredSize(new Dimension(300,150));
        
        // se puede seleccionar un texto
        // desde una posicin a otra
        // desde la posicin 2 a la 10
        tf1.setSelectionStart(2);
        tf1.setSelectionEnd(10);
        
        // se puede cambiar la fuente
        tf3.setFont(new Font("Arial",1,11));
        
        // se puede modificar el color
        tf3.setBackground(Color.red);
        tf3.setForeground(Color.blue);
        
        // se puede cambiar el texto inicial
        tf3.setText("ste es un nuevo texto diferente al inicial");
        
        // se puede cambiar la alineacin
        tf3.setHorizontalAlignment(SwingConstants.CENTER);
        
        // se asigna el gestor de distribucin en el contenedor
        this.getContentPane().setLayout(gl);
        
        // aade un gestor de escucha de teclado
        // para un campo JTextField
        tf2.addKeyListener(this);
        
        // se aaden los componentes al contenedor
        this.getContentPane().add(tf1,null);
        this.getContentPane().add(tf2,null);
        this.getContentPane().add(tf3,null);
        this.getContentPane().add(pf1,null);
        this.getContentPane().add(lbl,null);
        
                
        // visualizar ventana
        super.pack();
        this.setVisible(true);
        
        
        
        
        
    }
    // se aade un gestor de escucha
    // KeyListener
    
    public void keyReleased(KeyEvent e){};
    public void keyPressed(KeyEvent e){};    
    public void keyTyped(KeyEvent e){
        lbl.setText("Typed");
    };
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Ejemplo1405JTextField();
    }
    
}
