/*
 * PrcticaP1JSpinner.java
 *
 */
import java.awt.*;
import javax.swing.*;
/**
 *
 * @author Administrador
 */
public class PrcticaP1JSpinner  {
    
    public static void main(String[] args){
        // crear un Frame
        JFrame jfr = new JFrame("Test JSpinner");
        
        // obtener el contenedor del Frame
        Container cnt = jfr.getContentPane();
        
        // fijar el gestor de distribucin
        cnt.setLayout(new GridLayout(0,3));
        
        // Crea el objeto JSpinner
        //  se utiliza el modelo numrico
        JSpinner nums = new JSpinner(new SpinnerNumberModel());
        nums.setFont(new Font("Arial", Font.BOLD, 14));
        
        // se aade el control al contenedor
        cnt.add(nums);
        
        // Crea el objeto JSpinner
        //  se utiliza el modelo de fecha
        JSpinner fecha = new JSpinner(new SpinnerDateModel());
        fecha.setToolTipText("Cambia fechas");
        
        // se aade el control al contenedor
        cnt.add(fecha);
        
        // Crea el objeto JSpinner
        //  se utiliza el modelo de lista
        
        // lista de valores del control
        String[] mat = {"Lista 1", "Lista 2", "lista 3", "Lista 4"};
        
        JSpinner lista = new JSpinner(new SpinnerListModel(mat));
        
        // se aade el control al contenedor
        cnt.add(lista);
        
        // establece el tamao del Frame
        jfr.setSize(350, 60);
        
        // se hace visible
        jfr.setVisible(true);
        
    }
    
}
