/*
 * Ejemplo1501Thread.java
 *
 */

/**
 *
 * @author Administrador
 */
public class Ejemplo1501Thread extends Thread {
    
    // propiedades de la clase
    // msg mensaje
    // lContar para contar el bucle
    // lSleep para personalizar el tiempo
    // suspensin del subproceso
    String msg;
    long lContar;
    int lSleep;
    static long lSumar;
    
    /** Creates a new instance of Ejemplo1501Thread */
    public Ejemplo1501Thread(String nombre, long c, int tiempo) {
        
        // constructor del objeto
        lContar = c;
        msg = nombre;
        lSleep = tiempo;
        
        // avisa que se est ejecutando
        // comprobar que se inician ordenadamente
        // pero terminarn desordenadamente dado
        // que tienen diferentes tiempos de sleep
        System.out.println(nombre + ": ejecutando Thread");
        
    }
    // hay que implementar el mtodo run()
    public void run() {
        // el bucle lContar se hace
        // desde lContar hasta cero
        while(lContar-- > 0 ){
            try {
                // se suma en la variable de clase lSumar
                lSumar++;
                Thread.sleep(lSleep);
                
                
            } catch (InterruptedException e) {
                return;
                
            }
        }
        System.out.println(msg + ": finalizado, estado de la suma lSumar: " + lSumar);
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // se generan cuatro ejemplares
        // cada uno se ejecutar en un subproceso diferente
        // y con tiempos de espera diferentes
        // el tiempo es en milisegundos
        new Ejemplo1501Thread("Primer subproceso :", 100, 50).start();
        new Ejemplo1501Thread("Segundo subproceso :", 100, 12).start();
        new Ejemplo1501Thread("Tercer subproceso :", 100, 100).start();
        new Ejemplo1501Thread("Cuarto subproceso :", 100, 20).start();
    }
    
}
