/*
 * Ejemplo1505Thread.java
 *
 */

/**
 *
 * @author Administrador
 */
public class Ejemplo1505Thread extends Thread {
    // en este ejemplo no se utiliza sincronizacin
    // y se observa que el dato lSumar en lugar de llegar
    // a 6000 llega a un valor mucho menor
    // a medida que el bucle para perder tiempo
    // se hace ms grande, ms probabilidades
    // habr que el resultado sea incorrecto
    
    // propiedades de la clase
    // msg mensaje
    // lContar para contar el bucle
    
    String msg;
    long lContar;
    
    
    // variable de clase
    static long lSumar = 0;
    
    
    /** Creates a new instance of Ejemplo1505Thread */
    public Ejemplo1505Thread(String nombre, long c) {
        
        // constructor del objeto
        lContar = c;
        msg = nombre;
        
        
        // avisa que se est ejecutando
        // comprobar que se inician ordenadamente
        // pero terminarn desordenadamente dado
        // que tienen diferentes tiempos de sleep
        System.out.println(nombre + ": ejecutando Thread");
        
    }
    // hay que implementar el mtodo run()
    public  void run() {
        // el bucle lContar se hace
        // desde lContar hasta cero
        
        while(lContar-- > 0 ){
            
            // se lee la variable lSumar
            long lTemp = lSumar;
            
            // bucle para perder tiempo
            // y el control del procesador
            // con 70000 se genera un problema
            // de falta de sincronizacin
            long cont = 70000;
            while(cont-- > 0){
                long j = cont;
            }
            
            // se suma en la variable de clase lSumar
            lSumar = lTemp + 1;
            
            
        }
        // al terminar el tercer proceso se debera llegar a 6000!!
        System.out.println(msg + ": finalizado, estado de la suma lSumar: " + lSumar);
        
    }
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // se generan tres ejemplares
        // cada uno se ejecutar en un subproceso diferente
        
        Ejemplo1505Thread s1 = new Ejemplo1505Thread("Primer subproceso :", 2000) ;
        s1.start();
        // try {
        // con esto se indica que el subproceso vigente
        // es decir, el main, queda a la espera que termine
        // el subproceso
        // es como secuencializar el procesamiento
        //    s1.join();
        // } catch (InterruptedException e) {
        //     System.out.println("InterruptedException");
        //}
        Ejemplo1505Thread s2 = new Ejemplo1505Thread("Segundo subproceso :", 2000);
        s2.start();
        // try {
        //     s2.join();
        // } catch (InterruptedException e) {
        //     System.out.println("InterruptedException");
        //}
        new Ejemplo1505Thread("Tercer subproceso :", 2000).start();
        
    }
    
}