/*
 * Main.java
 */

package cap16;
import java.sql.*;

/**
 *
 * @author Administrador
 */
public class Main {
    // cap 16
    // ejemplo de conexin y cierre de un
    // origen de datos
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        // en este caso hay un origen de sistema
        // en ODBC con el nombre Licencias
        
        // cadena de conexin
        String url ="jdbc:odbc:Licencias";
        
        // bloque try/catch para detectar
        // excepciones de conexin
        try {
            // verifica la existencia de la clase
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            
            // establece la conexin utilizando
            // el string url, en este caso,
            // no requiere usuario nin contrasea
            Connection cnn = DriverManager.getConnection(url ,"","");
            
            // ... 
            // aqu podramos incluir accesos
            // y actualizaciones a la base de datos
            // ...
            
            // cierre de conexin
            cnn.close();
            System.out.println("OK: conexin cerrada");
        } catch (Exception e) {
            System.out.println("KO: no se pudo conectar " + e);
            
            
        }
    }
    
}
