/*
 * Ejemplo1601DB.java
 */
import java.sql.*;
/**
 *
 * @author Administrador
 */
public class Ejemplo1601DB {
    Connection cnn;
    
    /** Creates a new instance of Ejemplo1601DB */
    public Ejemplo1601DB() {
        // en este caso hay un origen de sistema
        // en ODBC con el nombre Licencias
        
        // cadena de conexin
        String url ="jdbc:odbc:Licencias";
        
        // bloque try/catch para detectar
        // excepciones de conexin
        try {
            // verifica la existencia de la clase
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            
            // establece la conexin utilizando
            // el string url, en este caso,
            // no requiere usuario nin contrasea
            cnn = DriverManager.getConnection(url ,"","");
            
            acceso();
            
            // cierre de conexin
            cnn.close();
            System.out.println("OK: conexin cerrada");
        } catch (Exception e) {
            System.out.println("KO: no se pudo conectar " + e);
            
            
        }
        
    }
    public void acceso(){
        try{
            String sql= "SELECT * FROM licencias";
            System.out.println("Formato nativo " + cnn.nativeSQL(sql));
            Statement stm = cnn.createStatement();
            ResultSet rs = stm.executeQuery(sql);
            System.out.println("OK acceso sql ");
        } catch (Exception e) {
            System.out.println("error en acceso sql " + e);
        }
    }
    public static void main(String args[]){
        new Ejemplo1601DB();
    }
}
