/*
 * Ejemplo1801InetAddress.java
 *
 * Created on 11 de mayo de 2006, 10:27
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import java.net.*;
/**
 *
 * @author Administrador
 */
public class Ejemplo1801InetAddress {
    
    /** Creates a new instance of Ejemplo1801InetAddress */
    public Ejemplo1801InetAddress() {
        // uso de la clase InetAddress
        try {
            // InetAddress ip = InetAddress.getLocalHost();
            InetAddress ip = InetAddress.getByName("www.sun.com");
            
            // getAddress
            // devuelve la direccin IP en matriz de byte
            byte[] b  = ip.getAddress();
            System.out.println("Direccin IP es " + b[0] + "." + b[1] + "." + b[2] + "."+ b[3]);
            
            // getHostAddress
            // devuelve la direccin IP del objeto InetAddress
            System.out.println("Direccin IP es " + ip.getHostAddress());
            
            // getCanonicalHostName
            // devuelve el nombre de dominio totalmente calificado
            System.out.println("Nombre de dominio totalmente calificado: " + ip.getCanonicalHostName());
            
            // getHostName
            // devuelve el nombre de este equipo
            System.out.println("Nombre del equipo: " + ip.getHostName());
            
            // getLocalHost
            // devuelve el nombre del equipo local
            System.out.println("Nombre del equipo local: " + ip.getLocalHost());
            
            // isLoopbackAddress
            // indica si es una direccin loopback
            System.out.println("Es loopback?: " + ip.isLoopbackAddress());
            
            
            
        } catch (UnknownHostException e) {
            System.out.println("Direccin de equipo no obtenida ");
        }
    }
    public static void main(String argv[]) {
        new Ejemplo1801InetAddress();
    }
}
