/*
 * Ejemplo1903XML.java
 *
 */
import java.beans.XMLDecoder;
import java.beans.XMLEncoder;
import java.io.*;
import javax.swing.*;
/**
 *
 * @author Administrador
 */
public class Ejemplo1903XML  {
    
    public static final String ARCHIVO = "xmltest.xml";
    
    /** Creates a new instance of Ejemplo1903XML */
    public Ejemplo1903XML() {
        
    }
    public void guardar(){
        try {
            // se crea un objeto XMLEncoder
            XMLEncoder xmlo = new XMLEncoder(
                    new BufferedOutputStream(
                    new FileOutputStream(ARCHIVO)));
            
            // se crea un objeto que se serializa como XML
            JPanel jp = new JPanel();
            JButton jb1 = new JButton("CLICK 1");
            JButton jb2 = new JButton("CLICK 2");
            JTextField jtf = new JTextField("Saludos");
            jp.add(jb1);
            jp.add(jb2);
            jp.add(jtf);
            
            // se escribe el archivo xml
            // con el contenido del objeto jp
            xmlo.writeObject(jp);
            
            xmlo.close();
        } catch (Exception e) {
            System.out.println("Excepcin en guardar()");
        }
    }
    
    public void recuperar(){
        try {
            // recuperamos el archivo XML
            XMLDecoder xmli = new XMLDecoder(
                    new BufferedInputStream(
                    new FileInputStream(ARCHIVO)));
            
            // leemos el contenido en un objeto
            Object obj =  xmli.readObject();
            
            // impresin del contenido
            System.out.println(obj);
            
            xmli.close();
            
        } catch (IOException e) {
            System.out.println("Excepcin en recuperar()");
        }
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        Ejemplo1903XML ej = new Ejemplo1903XML();
        ej.guardar();
        ej.recuperar();
        
    }
    
}
